/**
*
*   Copyright Kai Özer, 2003-2024
*
*   This file is part of MI-SUGAR.
*
*   MI-SUGAR is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation; either version 2 of the License, or
*   (at your option) any later version.
*
*   MI-SUGAR is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with MI-SUGAR; if not, write to the Free Software Foundation, Inc.,
*   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*
*/
#import <Foundation/Foundation.h>
#import "SimulatorOutputParser.h"

NS_ASSUME_NONNULL_BEGIN

extern NSString* const SpiceParserErrorDomain;

typedef NS_ENUM(NSUInteger, SpiceParserErrorCode) {
	SpiceParserErrorCodeGeneric,
	SpiceParserErrorCodeNumberOfValuesNotMatchingNumberOfVariables, ///< the number of values in a data row does not match the number of variables
	SpiceParserErrorCodeDataRowIndexOverflow,   ///< the extracted data row index exceeds the expected number of data rows
	SpiceParserErrorCodeMalformedComplexNumber, ///< unexpected format in string that should represent the real or imaginary part of complex number
} NS_SWIFT_NAME(SpiceParserErrorCode);


/// Scans SPICE output generated by `.PRINT` commands.
@interface SpicePrintOutputParser : NSObject <SimulatorOutputParser>

@end

NS_ASSUME_NONNULL_END
